
EXTERNAL PROCEDURE Unsubscribe
EXTERNAL PROCEDURE Subscribe

DEFINE CLASS Post_Event AS CUSTOM
	HIDDEN oCollection
	
	PROCEDURE Init
	THIS.oCollection = CREATEOBJECT("MyCollection")
	SET LIBRARY TO LOCFILE("POST_EVENT.FLL") ADDITIVE
	
	PROCEDURE Sub_As_Method
	LPARAMETERS toObject, tcEvent, tcName
	LOCAL cRet
	
	cRet = THIS.oCollection.AddElement(toObject, tcEvent, tcName,1)
	IF !EMPTY(cRet)
		Subscribe(tcEvent,"_screen."+this.Name+".OnPostEvent('"+cRet+"',<Msg>, 1)")
	ENDIF
	RETURN !EMPTY(cRet)

	PROCEDURE Sub_As_Property
	LPARAMETERS toObject, tcEvent, tcName
	LOCAL cRet
	
	cRet = 	THIS.oCollection.AddElement(toObject, tcEvent, tcName,0)
	IF !EMPTY(cRet)
		Subscribe(tcEvent,"_screen."+this.Name+".OnPostEvent('"+cRet+"',<Msg>,0)")
	ENDIF
	RETURN !EMPTY(cRet)
	
	PROCEDURE Unsubscribe
	LPARAMETERS toObject, tcEvent, tcName
	THIS.oCollection.RemoveElement(toObject, tcEvent, tcName)
	Unsubscribe(tcEvent)
	
	PROCEDURE OnPostEvent
	LPARAMETERS tcName, tcMes, tnType
	LOCAL loObject, lcTarget
	IF tnType = 0
		loObject = THIS.oCollection.&tcName..oParent
		lcTarget = THIS.oCollection.&tcName..cName
		loObject.&lcTarget = tcMes
	ELSE
		loObject = THIS.oCollection.&tcName..oParent
		lcTarget = THIS.oCollection.&tcName..cName
		IF ISNULL(loObject)
			&lcTarget(tcMes)
		ELSE
			loObject.&lcTarget(tcMes)
		ENDIF
	ENDIF
	
	PROCEDURE Destroy
	THIS.oCollection = NULL
	RELEASE LIBRARY POST_EVENT.FLL
ENDDEFINE

DEFINE CLASS MyElement AS Custom
	oParent = NULL
	cName = ""
	cEvent = ""
	nType = 0
	
	PROCEDURE Init
	LPARAMETERS toParent, tcEvent, tcName, tnType
	THIS.oParent = toParent
	THIS.cName = tcName
	THIS.cEvent = tcEvent
	THIS.nType = tnType
	
	PROCEDURE Destroy
	THIS.oParent = NULL
*	? 'Destroy: '+this.name
	
ENDDEFINE

DEFINE CLASS MyCollection AS Custom

	PROCEDURE AddElement
	LPARAMETERS toParent, tcEvent, tcName, tnType
	LOCAL cRet
	
	cRet = ""
	IF EMPTY(THIS.FindElement(toParent, tcEvent, tcName))
		cRet = SYS(2015)
		THIS.AddObject( cRet, "MyElement", toParent, tcEvent, tcName, tnType)
	ENDIF
	RETURN cRet
	

	PROCEDURE RemoveElement
	LPARAMETERS toParent, tcEvent, tcName
	LOCAL oName
	oName = THIS.FindElement(toParent, tcEvent, tcName)
	IF !EMPTY( oName )
		THIS.RemoveObject(oName)
	ENDIF

	HIDDEN PROCEDURE FindElement
	LPARAMETERS toParent, tcEvent, tcName
	LOCAL i, ret
	ret = ""
	
	FOR i = 1 TO THIS.ControlCount
		IF ISNULL(toParent) AND !ISNULL(THIS.Controls(i).oParent)
			LOOP
		ENDIF
		IF !ISNULL(toParent) AND ISNULL(THIS.Controls(i).oParent)
			LOOP
		ENDIF
			
		IF !ISNULL(toParent) 
			IF THIS.Controls(i).oParent # toParent
				LOOP
			ENDIF
		ENDIF
			
		IF THIS.Controls(i).cName = tcName ;
			AND THIS.Controls(i).cEvent = tcEvent
				
			ret = THIS.Controls(i).Name
			EXIT
		ENDIF
	ENDFOR
	RETURN ret

	PROCEDURE Destroy
	LOCAL i, obj_cnt
	obj_cnt = THIS.ControlCount
	IF obj_cnt > 0
		LOCAL ARRAY arObjects(obj_cnt)
		FOR i = 1 TO obj_cnt
			arObjects(i) = THIS.Controls(i).Name
		ENDFOR
	
		FOR i = 1 TO obj_cnt
			THIS.RemoveObject(arObjects(i))
		ENDFOR
	ENDIF
ENDDEFINE

